#nécessaire au réseau
import time, socket, os, binascii
socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

#nécessaire au chiffrement
import Crypto
from code import encrypt,decrypt, getKey

##################################################################
# PARTIE ENVOI DU FICHIER
##################################################################
def envoifichier(host,nomFich):
    print("chiffrement en cours...")
    encrypt(getKey("test"), nomFich)
    print("chiffrement terminé...")
    nomFich="(encrypted)"+nomFich
    try:
        fich = open(nomFich, "rb") # test si le fichier existe
        fich.close()
    except:
        print(" >> le fichier '" + nomFich + "' est introuvable.")
        time.sleep(2)
        exit()

    octets = os.path.getsize(nomFich) / 1024
    print(" >> OK : '" + nomFich + "' [" + str(octets) + " Ko]")
    print("")

    # Connexion au serveur
    ############################################
    print(" >> Connexion en cours avec " + host + "...")
    try:
        socket.connect((host, 2110)) # test si le serveur existe
    except:
        print(" >> le serveur '" + host + "' est introuvable.")
        time.sleep(2)
        exit()
        
    
    print("")
    print(" >> Vous etes connecte au serveur, patientez d'une reponse...")
    print("")
    socket.send(("NAME " + nomFich + "OCTETS " + str(octets)).encode(encoding='ISO-8859-1',errors='strict')) # Envoi du nom et de la taille du fichier  

    # Boucle temps que l'ont est connecte
    ############################################
    while (socket.connect):
        recu = socket.recv(1024)
        if not recu : break
        recu=recu.decode(encoding='utf-8',errors='strict')
        print(" >> Le serveur accepte le transfert")
        print(time.strftime(" >> [%H:%M] transfert en cours veuillez patienter..."))
        print(" ")

        try:
            fich = open(nomFich, "rb")
            # On envoi tous d'un coup
            donnees = fich.read()
            socket.send(donnees)
            fich.close()

        except:
            print("erreur de transmission...")
        print("")
        print(time.strftime(" >> Le %d/%m a %H:%M transfert termine !"))
#        socket.send("BYE".encode(encoding="ISO-8859-1",errors="strict")) # Envoi comme quoi le transfert est fini
        socket.close()
        break

##################################################################
# CREATION DU SERVEUR
##################################################################

def receptionfichier():
    print(" >> Creation du serveur (le pare feu peut alerter)")
    socket.bind(("0.0.0.0", 2110)) # Creation du serveur
    socket.listen(1) # Mise en ecoute d'un client
    
    print(" >> Attente d'une nouvelle connexion...")
    conn, adresse = socket.accept() # accepte le client

    print("")
    print(" >> Vous etes connecte avec : " + adresse[0])
    print("")

    accepte = "non"
    num = 0
    pourcent = 0
    # Boucle temps que l'ont est connecte
    ############################################
    while (conn.connect):
        recu = ""
        recu = conn.recv(2**25)
        if not recu : break
        recu = recu.decode(encoding='ISO-8859-1', errors='strict')

        if accepte == "non": # Condition si on a pas deja envoyer le nom et la taille du fichier
                nomFich = recu.split("NAME ")[1]
                nomFich = nomFich.split("OCTETS ")[0]
                taille = recu.split("OCTETS ")[1]
                print(" >> Fichier '" + nomFich + "' [" + taille + " Ko]")

                accepte =input(" >> Acceptez vous le transfert [o/n] : ") # demande si on accepte ou pas le transfert                               

                if accepte == "o" or accepte == "oui": # Si oui en lenvoi au client et on cree le fichier
                    conn.send(("GO").encode(encoding='ISO-8859-1',errors='strict'))
                    print(time.strftime(" >> [%H:%M] transfert en cours veuillez patienter..."))
                    print("")
                    f = open(nomFich, "wb")
                    identifier = "oui"
                    taille = float(taille) * 1024 # Conversion de la taille en octets pour le %
                                        
                else :
                    conn.send("Bye".encode(encoding='ISO-8859-1',errors='strict')) # Si pas accepte on ferme le programme

        
        elif recu == "BYE": # Si on a recu "BYE" le transfer est termine
            f.close()
            socket.close()
            print("")
            print(time.strftime(" >> Le %d/%m a %H:%M transfert termine !"))
            break
            
        else: # Sinon on ecrit au fur et a mesure dans le fichier
            f.write(bytes(recu.replace("BYE",""), "ISO-8859-1"))
